$table-color: $grey-darker !default
$table-background-color: $white !default

$table-cell-border: 1px solid nth($blue-grey-lighten, 2) !default
$table-cell-border-width: 0 0 0px !default
$table-cell-padding: 0.5em 0.75em !default
$table-cell-heading-color: $text-strong !default

$table-head-cell-border-width: 0 0 2px !default
$table-head-cell-color: $text-strong !default
$table-foot-cell-border-width: 2px 0 0 !default
$table-foot-cell-color: $text-strong !default

$table-row-hover-background-color: $white-bis !default

// $table-row-active-background-color: nth($red-lighten, 5) !default
$table-row-active-background-color: rgba($red, .05) !default
$table-row-active-color: $table-color !default

$table-striped-row-odd-background-color: rgb(247,248, 249) // rgba(#7d90a3, .1) !default
$table-striped-row-odd-hover-background-color: rgb(244,245,246) // rgba(#7d90a3,.2) !default
$table-striped-row-even-background-color: rgb(242,244,245) // rgba(#b3bdc6,.1)  !default
$table-striped-row-even-hover-background-color: rgb(239,241,242) // rgba(#b3bdc6,.2) !default

$transparent: rgba(0, 0, 0, 0)
$background: #ffffff
$shadow: rgba(0,0,0,.1)

.#{$namespace}-table-wrapper
  // +mobile
  overflow: auto
  // +tablet
  //   overflow: auto
  // +desktop
  //   overflow: auto
  +widescreen
    // overflow: visible
    .#{$namespace}-table
      th, td 
        white-space: normal

  margin: .5rem 0 1rem
  -webkit-overflow-scrolling: touch
  margin-bottom: 1rem
  background-image: linear-gradient(to right, $background 0, $background 50%, $background 100%), linear-gradient(to right, $background 0, $background 50%, $background 100%), linear-gradient(to right, $shadow, $transparent), linear-gradient(to left, $shadow, $transparent)
  background-position: 0 50%, 100% 50%
  background-repeat: no-repeat
  background-color: #fff
  background-size: 40px 100%, 40px 100%, 15px 100%, 15px 100%
  background-attachment: local, local, scroll, scroll

  &.has-no-scrollbar
    background-image: none
    overflow: hidden

  &::-webkit-scrollbar
    height: .3em
    width: .3em
  
  &::-webkit-scrollbar-track
    background-color: rgba(nth($black-lighten, 4),.5)

  &::-webkit-scrollbar-thumb
    background-color: $blue-grey

  &.is-bordered
    border: 1px solid nth($blue-grey-lighten, 4)
    .#{$namespace}-table
      .#{$namespace}-table-head
        .#{$namespace}-table-cell
          border-right: 1px solid nth($blue-grey-lighten, 4)
          &:last-child 
            border-right: 0
    .#{$namespace}-table > :not(.#{$namespace}-table-head)
      td,
      th,
      .#{$namespace}-table-cell
        &:last-child
          border-right: 0
        border-width: 0 1px 1px 0
        border-color: nth($blue-grey-lighten, 4)
    .#{$namespace}-table > :not(.#{$namespace}-table-head)
      tr, .#{$namespace}-table-row
        &:last-child
          td,
          th,
          .#{$namespace}-table-cell
            border-width: 0 1px 0 0
    tr, .#{$namespace}-table-row
      td, th, .#{$namespace}-table-cell
        &:first-child
          // border-left-width: 1px
          // border-top-width: 1px

  .#{$namespace}-table
    background-color: transparent

.#{$namespace}-table
  +block
  display: table
  width: 100%
  background-color: $table-background-color
  color: $table-color
  width: 100%
  td,
  th,
  &-cell
    display: table-cell
    box-sizing: border-box
    border: $table-cell-border
    border-width: $table-cell-border-width
    padding: $table-cell-padding
    vertical-align: top
    white-space: nowrap
    > span 
      white-space: normal

    sup
      font-size: .75em
      position: relative
      transform: translateY(12%)

    .#{$namespace}-button
      &.is-small
        margin-top: -3px
        margin-bottom: -3px
        &.is-round
          margin-top: -4px
          margin-bottom: -4px
          height: 1.75rem
          width: 1.75rem

    // Colors
    @each $name, $pair in $colors
      $color: nth($pair, 1)
      $color-invert: nth($pair, 2)
      &.is-#{$name}
        background-color: $color
        border-color: $color
        color: $color-invert
        
    // Modifiers
    &.is-narrow
      white-space: nowrap
      width: 1%
    &.is-selected
      background-color: $table-row-active-background-color
      color: $table-row-active-color
      a,
      strong
        color: currentColor
  th,
  &-head .#{$namespace}-table-cell
    color: $table-cell-heading-color
    text-align: left
    vertical-align: top
    line-height: 1.1
  tr, &-row
    display: table-row
    &.is-selected
      background-color: $table-row-active-background-color
      color: $table-row-active-color
      a,
      strong
        color: currentColor
      td,
      th
        // border-color: $table-row-active-color
        color: currentColor
  thead, &-head
    display: table-header-group
    td,
    th,
    .#{$namespace}-table-cell
      border-width: $table-head-cell-border-width
      color: $table-head-cell-color
      font-weight: bold
  tfoot, &-foot
    display: table-footer-group
    td,
    th,
    .#{$namespace}-table-cell
      border-width: $table-foot-cell-border-width
      color: $table-foot-cell-color
      vertical-align: top
      font-weight: bold
  tbody, &-body
    display: table-row-group
    tr
      th
        vertical-align: top
      &:last-child
        td,
        th
          border-bottom-width: 0
  // Modifiers
  
  // &.is-fullwidth
  //   width: 100%
  &.is-striped
    tbody, .#{$namespace}-table-body
      tr:not(.is-selected), .#{$namespace}-table-row:not(.is-selected)
        &:nth-child(odd)
          background-color: $table-striped-row-odd-background-color
          .#{$namespace}-table-cell
            background-color: $table-striped-row-odd-background-color
        &:nth-child(even)
          background-color: $table-striped-row-even-background-color
          .#{$namespace}-table-cell
            background-color: $table-striped-row-even-background-color
  &.is-hoverable
    tbody, .#{$namespace}-table-body
      tr:not(.is-selected), .#{$namespace}-table-row:not(.is-selected)
        &:hover
          background-color: $table-row-hover-background-color
          .#{$namespace}-table-cell
            background-color: $table-row-hover-background-color
    &.is-striped
      tbody, .#{$namespace}-table-body
        tr:not(.is-selected), .#{$namespace}-table-row:not(.is-selected)
          &:hover
            background-color: $table-striped-row-odd-hover-background-color
            .#{$namespace}-table-cell
              background-color: $table-striped-row-odd-hover-background-color
            &:nth-child(even)
              &:hover
                background-color: $table-striped-row-even-hover-background-color
                .#{$namespace}-table-cell
                  background-color: $table-striped-row-even-hover-background-color
  &.is-narrow
    td,
    th,
    .#{$namespace}-table-cell
      padding: 0.25em 0.5em
      .#{$namespace}-button
        margin-top: -2px
        margin-bottom: -2px
      .#{$namespace}-icon
        height: .8rem
        position: relative
        top: 2px
    th, .#{$namespace}-table-head .#{$namespace}-table-cell
      font-size: $size-7
